Bug 424370 - "Closable" window rule is not immediately applied to window decoration
Summary: "Closable" window rule is not immediately applied to window decoration
Status: RESOLVED FIXED
Alias: None
Product: kwin
Classification: Plasma
Component: rules (show other bugs)
Version: git master
Platform: Neon Linux
: NOR normal (vote)
Target Milestone: ---
Assignee: KWin default assignee
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-07-18 11:07 UTC by Patrick Silva
Modified: 2021-09-29 18:36 UTC (History)
2 users (show)

See Also:
Latest Commit:
Version Fixed In: 5.22.90


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Patrick Silva 2020-07-18 11:07:00 UTC
STEPS TO REPRODUCE
1. open Dolphin
2. Alt+F3 -> More actions -> Configure Special Application settings -> Add "Closable" Property -> Set it to Force "No", click on "Ok" button
3. right-click in Dolphin entry in task manager: "Close" option is still active
and "Close" button is still present in the window decoration of Dolphin
4. minimize and unminimize Dolphin
5. right-click on Dolphin entry in task manager again: now "Close" entry is greyed out but "Close" button is still present in the window decoration of Dolphin
6. quit Dolphin by pressing ctrl+q
7. reopen Dolphin: now there is no "Close" button in the window decoration

EXPECTED RESULT
"Close" entry of the context menu of Dolphin entry in task manager should be greyed out and close button should disappear from the window decoration immediately after the step 2.

SOFTWARE/OS VERSIONS
Operating System: KDE neon Unstable Edition
KDE Plasma Version: 5.19.80
KDE Frameworks Version: 5.73.0
Qt Version: 5.14.2
Comment 1 Bug Janitor Service 2021-09-04 13:51:13 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kwin/-/merge_requests/1378
Comment 2 Ismael Asensio 2021-09-04 16:50:59 UTC
Git commit 436011e0ec92e461b7a9b8571e063b5b1765ed49 by Ismael Asensio.
Committed on 04/09/2021 at 13:51.
Pushed by iasensio into branch 'master'.

X11Client: emit isCloseableChanged when updated

This allows the decoration buttons to be updated accordingly
when the status changes.

We also need to explicitely update allowed actions when rules
are applied, as `isCloseable` is not a settable property, but
an allowed action
FIXED-IN: 5.22.90

M  +6    -2    src/x11client.cpp

https://invent.kde.org/plasma/kwin/commit/436011e0ec92e461b7a9b8571e063b5b1765ed49